import Blender;
import struct;
#from Blender.Armature import *
#Blender.Ipo.New('Action','ipo');
#ipos=Blender.Ipo.Get('ipo')

obj=Blender.Object.Get('Sphere.001')
mesh=obj.getData();
#print Blender.NMesh.GetNames()
#mesh=Blender.NMesh.GetRaw('geometry_mesh');
vgroupnames=mesh.getVertGroupNames();

f=open('/tmp/weights.dat','wb');
f.write(struct.pack("I",len(vgroupnames)))

for name in vgroupnames:
	f.write(struct.pack("I",len(name)));
	f.write(name);
	print name
print len(mesh.verts)
f.write(struct.pack("I",len(mesh.verts)))

lists=[[] for i in range(len(mesh.verts))];
ind=0;
for name in vgroupnames:
	list=mesh.getVertsFromGroup(name,1);
	for vind,weight in list:
		lists[vind].append((ind,weight));
	ind=ind+1;
for i in range(len(mesh.verts)):
	f.write(struct.pack('I',len(lists[i])));
	for j in range(len(lists[i])):
		f.write(struct.pack('If',lists[i][j][0],lists[i][j][1]));
f.close();	

armature=Blender.Armature.Get();
print armature
armature=Blender.Armature.Get('Armature.001');
print armature.bones
bones=armature.bones;
print 'bones are:'
f=open('/tmp/output.txt','w');
armat=Blender.Object.Get('Armature').getMatrix('worldspace');

togame=Blender.Mathutils.Matrix([1,0,0,0],[0,0,-1,0],[0,1,0,0],[0,0,0,1]);
armat=armat*togame;
#print armat;
#armat=Blender.Mathutils.Matrix([1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,0,1]);
f.write(armat[0][0].__str__()+' ');
f.write(armat[0][1].__str__()+' ');
f.write(armat[0][2].__str__()+' ');
f.write(armat[0][3].__str__()+' ');
f.write(armat[1][0].__str__()+' ');
f.write(armat[1][1].__str__()+' ');
f.write(armat[1][2].__str__()+' ');
f.write(armat[1][3].__str__()+' ');
f.write(armat[2][0].__str__()+' ');
f.write(armat[2][1].__str__()+' ');
f.write(armat[2][2].__str__()+' ');
f.write(armat[2][3].__str__()+' ');
f.write(armat[3][0].__str__()+' ');
f.write(armat[3][1].__str__()+' ');
f.write(armat[3][2].__str__()+' ');
f.write(armat[3][3].__str__()+'\n');

for bone_name in bones.keys():
	bone=bones[bone_name]
	#print bone_name
	#print bone.matrix['ARMATURESPACE']
	#print 'deform: ',bone.deform_dist
	#print 'length: ',bone.length
	#print 'roll:',bone.roll['BONESPACE']
	
	print 'Roll',bone.roll['ARMATURESPACE'],bone.roll['BONESPACE'];
	roll=bone.roll['ARMATURESPACE'];
	head=bone.head['BONESPACE'];
	tail=bone.tail['BONESPACE'];
	
	mat=bone.matrix['BONESPACE'];
	if(bone.hasParent()):
		mat=bone.matrix['BONESPACE'];
		head=bone.head['BONESPACE'];
		tail=bone.tail['BONESPACE'];	
	#else:
		#print 'noparent'
		#trans=Blender.Mathutils.Vector(mat[3][0],mat[3][1],mat[3][2]);
		#head=head-trans;
		#tail=tail-trans;
	
#	quat=bone.getQuat();
#	roll=bone.getRoll();
#	size=bone.getSize();
	f.write(bone.name+' ');
	f.write(head[0].__str__()+' ');
	f.write(head[1].__str__()+' ');
	f.write(head[2].__str__()+' ');
	f.write(tail[0].__str__()+' ');
	f.write(tail[1].__str__()+' ');
	f.write(tail[2].__str__()+' ');
	f.write(mat[0][0].__str__()+' ');
	f.write(mat[0][1].__str__()+' ');
	f.write(mat[0][2].__str__()+' ');
	f.write(mat[1][0].__str__()+' ');
	f.write(mat[1][1].__str__()+' ');
	f.write(mat[1][2].__str__()+' ');
	f.write(mat[2][0].__str__()+' ');
	f.write(mat[2][1].__str__()+' ');
	f.write(mat[2][2].__str__()+' ');
	f.write(roll.__str__());
	if(bone.hasParent()):
		f.write(' '+bone.parent.name+'\n');
		#print bone.name,head[0],head[1],head[2],tail[0],tail[1],tail[2],roll,bone.parent.name
	else:
		f.write('\n');
		#print bone.name,head[0],head[1],head[2],tail[0],tail[1],tail[2],roll
#print 'done bones'
		
#print bones
acts=Blender.Armature.NLA.GetActions()

#print acts['Action']
for name in acts.keys():
	act=acts[name];
	 
	ipos=act.getAllChannelIpos()
	print name,len(ipos)
	f.write(name+' '+(len(ipos)).__str__()+'\n');
	for ipo_name in ipos.keys():
		curves=ipos[ipo_name].getCurves()
		f.write(ipo_name+' '+(len(curves)).__str__()+'\n');
		#print ipo_name,len(curves)
		for curve in curves:
			#print name,ipo_name,curve.getName(),
			pts=curve.getPoints();
			f.write(curve.getName()+' '+(len(pts)).__str__()+'\n');
			#print curve.getName(),len(pts)
			for pt in pts:
				#print pt.getPoints();
				triple=pt.getTriple();
				f.write(triple[0][0].__str__()+' ');
				f.write(triple[0][1].__str__()+' ');
				f.write(triple[0][2].__str__()+' ');
				f.write(triple[1][0].__str__()+' ');
				f.write(triple[1][1].__str__()+' ');
				f.write(triple[1][2].__str__()+' ');
				f.write(triple[2][0].__str__()+' ');
				f.write(triple[2][1].__str__()+' ');
				f.write(triple[2][2].__str__()+'\n');
				#print triple[0][0],triple[0][1],triple[0][2],triple[1][0],triple[1][1],triple[1][2],triple[2][0],triple[2][1],triple[2][2]
f.close();