import Blender;
import Blender.Mathutils;
import struct;
objs=Blender.Object.Get();

for obj in objs:
	if  obj.getType()=='Mesh':
		mesh=obj.getData();
		
		mats=mesh.getMaterials();
		f=open('/tmp/obj.nbi','w');
		f.write(struct.pack('I',len(mats)));
		for m in mats:
			diff=m.getRGBCol();
			spec=m.getSpecCol();
			f.write(struct.pack('f',m.getAmb()));
			f.write(struct.pack('f',m.getEmit()));
			f.write(struct.pack('f',m.getAlpha()));
			f.write(struct.pack('f',float(m.getHardness())));
			f.write(struct.pack('fff',diff[0],diff[1],diff[2]));
			f.write(struct.pack('fff',spec[0],spec[1],spec[2]));
			
			texs = m.getTextures();	
			ntex=0;
			for t in texs:
				if t!=None:
					ntex=ntex+1;
			f.write(struct.pack('I',ntex));	
			
			for t in texs:
				if t!=None:
					print dir(Blender.Texture)
					if t.tex.getType()=='Image':
						print 'Got Image Texture'
						print Blender.Texture.BlendModes
						print t.blendmode
						print t.tex.getImage()
						print t.tex.getImage().getFilename()
		
						#null terminated string, should be relative
						#FIXME: remove the actual directory string
						bdir='/home/birkbeck/gt/';
					
						relfile=t.tex.getImage().getFilename()
						relfile=relfile.replace(bdir,'./');
						print relfile
						f.write(relfile+'\0');
						
						# blendmode,texco type, mapsto FIXME: unset
						f.write(struct.pack('II',0,0));
						
						if t.texco==Blender.Texture.TexCo.UV:
							print 'got uv texcoords'
						else:
							print 'only works with uv tex coords'			
						
						
						
						if t.mapto==Blender.Texture.MapTo.COL:
							print 'maps to color'
							f.write('col');
						elif t.mapto==Blender.Texture.MapTo.NOR:
							print 'maps to normal'
							f.write('nor');
						elif t.mapto==Blender.Texture.MapTo.SPEC:
							print 'maps to spec'
							f.write('spe');
						elif t.mapsto==Blender.Texture.MapTo.HARD:
							print 'maps to hardness'
							f.write('har');
						elif t.mapsto==Blender.Texture.MapTo.EMIT:
							print 'maps to emit'
							f.write('emi');
					else:
						print 'Type: ',t.tex.getType(), 'not handled'
						
		print mats;
		
		
		mat=obj.getMatrix('worldspace');
		togame=Blender.Mathutils.Matrix([1,0,0,0],[0,0,-1,0],[0,1,0,0],[0,0,0,1]);
		mat=mat*togame;
	
		f.write(struct.pack('I',len(mesh.verts)));
		for v in mesh.verts:
			vco=Blender.Mathutils.Vector(v.co[0],v.co[1],v.co[2],1);
		
			#transform the point into world space	
			vco=vco*mat;
			f.write(struct.pack('fff',vco[0],vco[1],vco[2]));
			#f.write('v '+vco[0].__str__());
			#f.write(' '+vco[1].__str__());
			#f.write(' '+vco[2].__str__()+'\n');
		#for v in mesh.verts:
			#f.write(struct.pack('fff',v.no[0],v.no[1],v.no[2]));
			#f.write('vn '+v.no[0].__str__());
			#f.write(' '+v.no[1].__str__());
			#f.write(' '+v.no[2].__str__()+'\n');
		
		#keep track of unique uv's and output them
		uvs={};
		uvs_out=[];
		ind=0;
		for e in mesh.faces:	
			for uv in e.uv:
				if uvs.has_key(uv)==0:
					uvs[uv]=ind;
					ind=ind+1;
					uvs_out.append((uv[0],1-uv[1]));
		f.write(struct.pack('I',ind));
		for uv in uvs_out:
			f.write(struct.pack('ff',uv[0],uv[1]));
		
		print '# uvs ',ind, ' nvert',len(mesh.verts)
		
		nface=0;
		for e in mesh.faces:
			nface=nface+1;
			if(len(e)==4):
				nface=nface+1;
				
		f.write(struct.pack('I',nface));
		print 'nfaces:',nface
		for e in mesh.faces:
			f.write(struct.pack('B',((e.smooth<<7)|e.materialIndex)));				
			f.write(struct.pack('III',e[0].index,e[1].index,e[2].index));
			f.write(struct.pack('III',uvs[e.uv[0]],uvs[e.uv[1]],uvs[e.uv[2]]));
			if(len(e.v)==4):
				f.write(struct.pack('B',((e.smooth<<7)|e.materialIndex)));
				f.write(struct.pack('III',e[0].index,e[2].index,e[3].index));
				f.write(struct.pack('III',uvs[e.uv[0]],uvs[e.uv[2]],uvs[e.uv[3]]));
			
			if 0:
				f.write('f '+(e[0].index+1).__str__());
				f.write('/'+(uvs[e.uv[0]]+1).__str__());
				
				f.write(' '+(e[1].index+1).__str__());
				f.write('/'+(uvs[e.uv[1]]+1).__str__());
				
				f.write(' '+(e[2].index+1).__str__());
				f.write('/'+(uvs[e.uv[2]]+1).__str__()+'\n');
				
				if len(e.v)==4:
					f.write('f '+(e[0].index+1).__str__());
					f.write('/'+(uvs[e.uv[0]]+1).__str__());
				
					f.write(' '+(e[2].index+1).__str__());
					f.write('/'+(uvs[e.uv[2]]+1).__str__());
				
					f.write(' '+(e[3].index+1).__str__());
					f.write('/'+(uvs[e.uv[3]]+1).__str__()+'\n');
				
		f.close();
				
			
				
	